package cn.iocoder.yudao.module.smartfactory.service.screendata;

import cn.hutool.json.JSON;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import cn.iocoder.yudao.framework.common.util.json.JsonUtils;
import cn.iocoder.yudao.module.smartfactory.controller.screendata.factory.vo.*;
import cn.iocoder.yudao.module.smartfactory.framework.util.HttpUtil;
import com.fasterxml.jackson.databind.JsonNode;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 功能描述
 *
 * @author: yj
 * @date: 2024年03月06日 11:54
 */
@Service
@Validated
public class ScreenDataServiceImpl implements ScreenDataService{
    @Override
    public List<ProvincesDataRespVO> getProvincesData(Integer type,String adcode) {
        return null;
    }

    @Override
    public StaffDataRespVO getStaffData(Long factoryId) {
        return null;
    }

    @Override
    public PropertyDataRespVO getPropertyData(Long factoryId) {
        return null;
    }

    @Override
    public OperateDataRespVO getFactoryOperateData(Long factoryId) {
        return null;
    }

    @Override
    public FactoryRollDataRespVO getFactoryRollData() {
        return null;
    }

    @Override
    public List<FactoryCameraDataRespVO> getFactoryCamerasData(Long factoryId) {
        return null;
    }


    private static final String WEATHER_URL = "https://d1.weather.com.cn/sk_2d/";
    private static final String REFERER = "referer";
    private static final String REFERER_URL = "http://www.weather.com.cn/";
    private static final String WEATHER_SPLIT = "dataSK=";

    public FactoryWeatherDataRespVO getFactoryWeatherInfo(Long factoryId) {
        //根据factoryId 查询areaCode;
        String areaCode = "101190101" ;
        String url = WEATHER_URL + areaCode + ".html";
        Map<String, String> headers = new HashMap<>();
        headers.put(REFERER, REFERER_URL);
        String result = HttpUtil.doGetSetHeader(url, headers);
        String[] str = result.split(WEATHER_SPLIT);
        if(str.length > 1) {
            FactoryWeatherDataRespVO vo = new FactoryWeatherDataRespVO();
            JSONObject jsonObject = JSONUtil.parseObj(str[1]) ;
            vo.setFactoryId(factoryId);
            vo.setAreaCode(areaCode) ;
            vo.setTemperature(jsonObject.getStr("temp")) ; //温度
            vo.setHumidity(jsonObject.getStr("sd"));       //湿度
            vo.setWeather(jsonObject.getStr("weather")) ;  //天气
            vo.setDate(jsonObject.getStr("date"));         //日期
            return vo ;
        }else {
            return null ;
        }
    }

    public List<FactoryPackLineDataRespVO>  getFactoryPackLineInfo(Integer type, Long factoryId) {
        return null ;
    }
}
